diff --git a/examples/qos_sched/cfg_file.c b/examples/qos_sched/cfg_file.c
index 595e70b..94a1a22 100644
--- a/examples/qos_sched/cfg_file.c
+++ b/examples/qos_sched/cfg_file.c
@@ -49,189 +49,6 @@
  * for new entries do we add in */
 #define CFG_ALLOC_ENTRY_BATCH 16
 
-static unsigned
-_strip(char *str, unsigned len)
-{
-	int newlen = len;
-	if (len == 0)
-		return 0;
-
-	if (isspace(str[len-1])) {
-		/* strip trailing whitespace */
-		while (newlen > 0 && isspace(str[newlen - 1]))
-			str[--newlen] = '\0';
-	}
-
-	if (isspace(str[0])) {
-		/* strip leading whitespace */
-		int i,start = 1;
-		while (isspace(str[start]) && start < newlen)
-			start++
-			; /* do nothing */
-		newlen -= start;
-		for (i = 0; i < newlen; i++)
-			str[i] = str[i+start];
-		str[i] = '\0';
-	}
-	return newlen;
-}
-
-struct cfg_file *
-cfg_load(const char *filename, int flags)
-{
-	int allocated_sections = CFG_ALLOC_SECTION_BATCH;
-	int allocated_entries = 0;
-	int curr_section = -1;
-	int curr_entry = -1;
-	char buffer[256];
-	int lineno = 0;
-	struct cfg_file *cfg = NULL;
-
-	FILE *f = fopen(filename, "r");
-	if (f == NULL)
-		return NULL;
-
-	cfg = malloc(sizeof(*cfg) +	sizeof(cfg->sections[0]) * allocated_sections);
-	if (cfg == NULL)
-		goto error2;
-
-	memset(cfg->sections, 0, sizeof(cfg->sections[0]) * allocated_sections);
-
-	while (fgets(buffer, sizeof(buffer), f) != NULL) {
-		char *pos = NULL;
-		size_t len = strnlen(buffer, sizeof(buffer));
-		lineno++;
-		if (len >=sizeof(buffer) - 1 && buffer[len-1] != '\n'){
-			printf("Error line %d - no \\n found on string. "
-					"Check if line too long\n", lineno);
-			goto error1;
-		}
-		if ((pos = memchr(buffer, ';', sizeof(buffer))) != NULL) {
-			*pos = '\0';
-			len = pos -  buffer;
-		}
-
-		len = _strip(buffer, len);
-		if (buffer[0] != '[' && memchr(buffer, '=', len) == NULL)
-			continue;
-
-		if (buffer[0] == '[') {
-			/* section heading line */
-			char *end = memchr(buffer, ']', len);
-			if (end == NULL) {
-				printf("Error line %d - no terminating '[' found\n", lineno);
-				goto error1;
-			}
-			*end = '\0';
-			_strip(&buffer[1], end - &buffer[1]);
-
-			/* close off old section and add start new one */
-			if (curr_section >= 0)
-				cfg->sections[curr_section]->num_entries = curr_entry + 1;
-			curr_section++;
-
-			/* resize overall struct if we don't have room for more sections */
-			if (curr_section == allocated_sections) {
-				allocated_sections += CFG_ALLOC_SECTION_BATCH;
-				struct cfg_file *n_cfg = realloc(cfg, sizeof(*cfg) +
-						sizeof(cfg->sections[0]) * allocated_sections);
-				if (n_cfg == NULL) {
-					printf("Error - no more memory\n");
-					goto error1;
-				}
-				cfg = n_cfg;
-			}
-
-			/* allocate space for new section */
-			allocated_entries = CFG_ALLOC_ENTRY_BATCH;
-			curr_entry = -1;
-			cfg->sections[curr_section] = malloc(sizeof(*cfg->sections[0]) +
-					sizeof(cfg->sections[0]->entries[0]) * allocated_entries);
-			if (cfg->sections[curr_section] == NULL) {
-				printf("Error - no more memory\n");
-				goto error1;
-			}
-
-			snprintf(cfg->sections[curr_section]->name,
-					sizeof(cfg->sections[0]->name),
-					"%s", &buffer[1]);
-		}
-		else {
-			/* value line */
-			if (curr_section < 0) {
-				printf("Error line %d - value outside of section\n", lineno);
-				goto error1;
-			}
-
-			struct cfg_section *sect = cfg->sections[curr_section];
-			char *split[2];
-			if (rte_strsplit(buffer, sizeof(buffer), split, 2, '=') != 2) {
-				printf("Error at line %d - cannot split string\n", lineno);
-				goto error1;
-			}
-
-			curr_entry++;
-			if (curr_entry == allocated_entries) {
-				allocated_entries += CFG_ALLOC_ENTRY_BATCH;
-				struct cfg_section *n_sect = realloc(sect, sizeof(*sect) +
-						sizeof(sect->entries[0]) * allocated_entries);
-				if (n_sect == NULL) {
-					printf("Error - no more memory\n");
-					goto error1;
-				}
-				sect = cfg->sections[curr_section] = n_sect;
-			}
-
-			sect->entries[curr_entry] = malloc(sizeof(*sect->entries[0]));
-			if (sect->entries[curr_entry] == NULL) {
-				printf("Error - no more memory\n");
-				goto error1;
-			}
-
-			struct cfg_entry *entry = sect->entries[curr_entry];
-			snprintf(entry->name, sizeof(entry->name), "%s", split[0]);
-			snprintf(entry->value, sizeof(entry->value), "%s", split[1]);
-			_strip(entry->name, strnlen(entry->name, sizeof(entry->name)));
-			_strip(entry->value, strnlen(entry->value, sizeof(entry->value)));
-		}
-	}
-	fclose(f);
-	cfg->flags = flags;
-	cfg->sections[curr_section]->num_entries = curr_entry + 1;
-	cfg->num_sections = curr_section + 1;
-	return cfg;
-
-error1:
-	cfg_close(cfg);
-error2:
-	fclose(f);
-	return NULL;
-}
-
-
-int cfg_close(struct cfg_file *cfg)
-{
-	int i, j;
-
-	if (cfg == NULL)
-		return -1;
-
-	for(i = 0; i < cfg->num_sections; i++) {
-		if (cfg->sections[i] != NULL) {
-			if (cfg->sections[i]->num_entries) {
-				for(j = 0; j < cfg->sections[i]->num_entries; j++) {
-					if (cfg->sections[i]->entries[j] != NULL)
-						free(cfg->sections[i]->entries[j]);
-				}
-			}
-			free(cfg->sections[i]);
-		}
-	}
-	free(cfg);
-
-	return 0;
-}
-
 int
 cfg_load_port(struct rte_cfgfile *cfg, struct rte_sched_port_params *port_params)
 {
diff --git a/examples/qos_sched/cfg_file.h b/examples/qos_sched/cfg_file.h
index 960cea4..cc5a2cd 100644
--- a/examples/qos_sched/cfg_file.h
+++ b/examples/qos_sched/cfg_file.h
@@ -37,39 +37,10 @@
 #include <rte_sched.h>
 #include <rte_cfgfile.h>
 
-#define CFG_NAME_LEN 32
-#define CFG_VALUE_LEN 64
-
-struct cfg_entry {
-	char name[CFG_NAME_LEN];
-	char value[CFG_VALUE_LEN];
-};
-
-struct cfg_section {
-	char name[CFG_NAME_LEN];
-	int num_entries;
-	struct cfg_entry *entries[0];
-};
-
-struct cfg_file {
-	int flags;
-	int num_sections;
-	struct cfg_section *sections[0];
-};
-
-
 int cfg_load_port(struct rte_cfgfile *cfg, struct rte_sched_port_params *port);
 
 int cfg_load_pipe(struct rte_cfgfile *cfg, struct rte_sched_pipe_params *pipe);
 
 int cfg_load_subport(struct rte_cfgfile *cfg, struct rte_sched_subport_params *subport);
 
-/* reads a config file from disk and returns a handle to the config
- * 'flags' is reserved for future use and must be 0
- */
-struct cfg_file *cfg_load(const char *filename, int flags);
-
-/* cleans up memory allocated by cfg_load() */
-int cfg_close(struct cfg_file *cfg);
-
 #endif